/*
ChrispyChars defines
	by Lach

v1.2
*/

local CC = ChrispyChars

CC.DEBUGPREFIX = "\139ChrispyChars:\128 " // prefix for prints

// high five stuff
CC.HIGHFIVE_RADIUS = 256*FRACUNIT // players need to be this close to initiate a high five
CC.HIGHFIVE_HEIGHT = 64*FRACUNIT // height above the ground at which a high five should connect
CC.HIGHFIVE_DELAY = 3*TICRATE/4 // players face each other for this long before leaping
CC.HIGHFIVE_SPEED = 8*FRACUNIT // horizontal speed of the leap
CC.HIGHFIVE_CONTACT = 70*FRACUNIT // players need to be this close to each other horizontally to make contact
CC.HIGHFIVE_PALMHEIGHT = 16*FRACUNIT // players need to be this close to each other vertically to make contact
CC.HIGHFIVE_PALMWIDTH = 9*FRACUNIT

// bot stuff
CC.BOTDELAYS = {}
CC.BOTDELAYS.DAB_ENTER = 4*TICRATE/3
CC.BOTDELAYS.DAB_EXIT = TICRATE
CC.BOTDELAYS.CROUCH = TICRATE/8
CC.BOTDELAYS.EMOTE = TICRATE/2

CC.BOT_COPYVARS = {
	"cc_neckenabled",
	"cc_curiosityenabled",
	"cc_emotionenabled",
	"cc_tricksenabled",
	"cc_confetticolors",
	"cc_flickerenabled",
	"cc_gaugeenabled",
	"cc_thatstailsenabled"
}

CC.BOT_COPYPOWERS = {
	pw_invulnerability,
	pw_sneakers
}

CC.BOT_SWAPPOWERS = {
	pw_flashing,
	pw_shield,
	pw_underwater,
	pw_spacetime,
	pw_gravityboots,
	pw_dye
}

// I want to use constants but also support 2.2.9 :v
CC.BOT_NONE = BOT_NONE or 0
CC.BOT_2PAI = BOT_2PAI or 1
CC.BOT_2PHUMAN = BOT_2PHUMAN or 2

// Shield properties
// e.g. ChrispyChars.shieldProperties[SH_BOULDER] = ChrispyChars.SHIELDFLAGS.NOABILITYCOMBO
CC.shieldProperties = {}

CC.SHIELDFLAGS = {}
CC.SHIELDFLAGS.NOABILITYCOMBO = 1 << 0 // prevents drop dash, bounce, etc. from being used while PF_SHIELDABILITY is active
CC.SHIELDFLAGS.NOMULTIPLEDROPDASH = 1 << 1 // prevents drop dashing once SF_NOSHIELDABILITY is removed