/*
ChrispyChars hooks
	by Lach

v1.2
*/

local CC = ChrispyChars

CC.hooks = {}

// runs all of the hooks associated with @hookType
CC.RunHook = function(key, hookType, ...)
	local returnValue
	for i, func in ipairs(CC.hooks[key][hookType])
		local ret = func(...)
		if ret ~= nil
			returnValue = ret
		end
	end
	return returnValue
end

// hooks @func so that it is called when @hookType is run
CC.AddHook = function(hookType, func, extraArg)
	local key = extraArg or MT_NULL
	local hookExists = false
	local hooks = CC.hooks[key]
	
	// if necessary, create hook table for this string/object type
	if not hooks
		hooks = {}
		CC.hooks[key] = hooks
	end
	
	// if necessary, create a new table in the hook table for this hook type, and hook it
	if not hooks[hookType]
		hooks[hookType] = {}
		addHook(hookType, function(...)
			return CC.RunHook(key, hookType, ...)
		end, extraArg)
	end
	
	// add this function to the hook's list
	table.insert(hooks[hookType], func)
end