/*
ChrispyChars Neck definitions
	by Lach

v1.2
*/

// This stuff is in a separate script for 2 reasons:
// 1) it used to bloat the FUCK out of Pointy's script
// 2) I want this conveniently loaded before CHRISPYCHARS-EMOTES

local CC = ChrispyChars

local function valid(mo)
	return mo and mo.valid
end

CC.emoteFuncs = {}
local EF = CC.emoteFuncs

EF.Squiggle = function(emote)
	P_TeleportMove(emote,
		emote.x + P_RandomRange(-1, 1)*emote.scale,
		emote.y + P_RandomRange(-1, 1)*emote.scale,
		emote.z + P_RandomRange(-1, 1)*emote.scale)
end

EF.Pulsate = function(emote, item, mo, rate)
	rate = $ or 12
	emote.z = $ + 4*P_MobjFlip(emote)*mo.scale
	emote.threshold = ($ + 1) % rate
	if emote.threshold < 6
		emote.scale = 3*$/2
		emote.z = $ - P_MobjFlip(emote)*4*emote.scale
	end
end

EF.Bob = function(emote)
	emote.threshold = ($ + 1) % 72
	emote.z = $ + 3*emote.scale + 3*FixedMul(sin(emote.threshold*(ANG10/2)), emote.scale)
end

EF.Exclamation = function(emote, item, mo)
	EF.Pulsate(emote, item, mo)
	if emote.threshold < 6
		if item.flags & MF_BOSS
			emote.color = SKINCOLOR_CRIMSON
		elseif item.player
			emote.color = item.player.skincolor
		else
			emote.color = SKINCOLOR_RED
		end
	end
end

EF.Question = function(emote)
	emote.threshold = ($ + 1) % 36
	emote.z = $ + 6*P_MobjFlip(emote)*FixedMul(abs(sin(emote.threshold*ANG10)), emote.scale)
	if emote.cusval
		emote.rollangle = FixedMul(ANG30, cos(emote.threshold*ANG10))
	elseif emote.threshold < 18
		emote.rollangle = FixedMul((36 - emote.threshold)*FRACUNIT >> 2, (2*(emote.threshold/2 & 1) - 1)*ANG1)
	end
end

EF.Sneeze = function(emote, item, mo)
	local EMOTEDELAY = 5*TICRATE/3 // countdown until emote appears
	local SNEEZETHRESHOLD = 2*TICRATE/5 // countdown until sneeze
	
	if emote.movedir ~= emote.lastlook
		emote.threshold = -EMOTEDELAY
	end
	
	if emote.threshold >= 0
		EF.Question(emote)
		return
	end
	
	emote.state = S_INVISIBLE
	
	if mo.tics < CC_NECK_TRANSITIONTIME
		return
	end
	
	emote.threshold = $ + 1
	if emote.threshold == -(EMOTEDELAY - SNEEZETHRESHOLD)
		local head = mo.neck.heads[2]
		if valid(head)
			head.state = S_POINTY_SNEEZE1
			S_StartSound(mo, sfx_sneeze)
		end
	elseif emote.threshold == 0
		S_StartSound(mo, sfx_emot2)
	end
end

EF.Icon = function(emote, item)
	local z = emote.z
	local flip = P_MobjFlip(emote)
	emote.threshold = ($ + 1) % 72
	emote.z = $ + 6*flip*FixedMul(abs(sin(emote.threshold*ANG10/2)), emote.scale)
	emote.scale = $ + flip*(emote.z - z)/64
end

EF.PlayerIcon = function(emote, item)
	if item.player
		if emote.skin ~= item.skin
			emote.skin = item.skin
		end
		emote.color = item.player.skincolor
	else
		emote.color = skins[emote.skin].prefcolor
	end
	emote.state = $
	emote.z = $ + P_MobjFlip(emote)*4*emote.scale
	EF.Icon(emote, item)
end

EF.Giggle = function(emote, item)
	emote.threshold = ($ + 1) % 6
	if emote.threshold < 3
		emote.z = $ + P_MobjFlip(emote)*2*emote.scale
	end
end

EF.Hater = function(emote, item, mo)
	emote.threshold = ($ + 1) % TICRATE
	if emote.threshold < TICRATE/3
		EF.Squiggle(emote)
	end
	if mo.player
		emote.color = mo.player.skincolor
	end
end

EF.OkHand = function(emote, item, mo)
	local ang
	local flip = P_MobjFlip(emote)
	emote.z = $ + flip*3*mo.scale
	emote.threshold = ($ + 1) % (2*TICRATE)
	ang = FixedAngle(360*(emote.threshold % TICRATE)*FRACUNIT/TICRATE)
	
	if emote.threshold < TICRATE
		emote.rollangle = ang
	else
		local ogscale = emote.scale
		emote.scale = $ + abs(sin(ang))/2
		emote.z = $ - P_MobjFlip(emote)*10*(emote.scale - ogscale)
	end
end

EF.DabParticles = function(emote, item, mo)
	emote.threshold = ($ + 1) % 40
	if emote.threshold % 10 == 0
		local n = emote.threshold / 10 % 4
		local colors = {SKINCOLOR_SUPERGOLD5, SKINCOLOR_ROSY, SKINCOLOR_NONE, SKINCOLOR_SKY}
		local part = P_SpawnMobjFromMobj(emote, 0, 0, 0, MT_PARTICLE)
		part.momz = P_MobjFlip(part)*mo.scale
		part.momx = P_RandomRange(-1, 1)*mo.scale
		part.momy = P_RandomRange(-1, 1)*mo.scale
		part.scale = 0
		part.destscale = mo.scale
		part.scalespeed = part.destscale/6
		part.fuse = 16
		part.sprite = SPR_EMOT
		part.frame = n + 2
		part.color = colors[n + 1]
	end
end

EF.Surprised = function(emote, item, mo)
	EF.Pulsate(emote, item, mo, 10)
	if mo.skin == "pointy"
		emote.color = mo.player.skincolor
	else
		emote.color = skins["pointy"].prefcolor
	end
end

EF.CLAPTIME = 6
EF.Clap = function(emote, item, mo)
	local dance = item.cc_dance
	
	if not dance return end
	
	if emote.movedir ~= emote.lastlook
	or emote.danceskin ~= dance.skin // yeah, I have to cheat a bit...
		local info = CC_DanceSkins[dance.skin]
		local time = 0
		local keys = info[dance.num].keys
		for i = 1, #keys
			time = $ + keys[i].tics
		end
		time = $ / (2*EF.CLAPTIME) + 1
		emote.threshold = (#keys / time) << 16
		emote.danceskin = dance.skin
	end
	
	if (dance.key - 1) % (emote.threshold >> 16) == 0//((emote.threshold >> 8) & 7)
	and emote.threshold & 7 == 0
		S_StartSound(mo, sfx_emot5)
		emote.threshold = $ + EF.CLAPTIME
		//emote.threshold = $ & ~(7 << 8) + (P_RandomKey(2) << 8)
	end
	
	if emote.threshold & 7
		emote.threshold = $ - 1
		emote.frame = $ + 1
	end
end	

EF.Cash = function(emote)
	emote.threshold = ($ + 1) % 40
	if emote.threshold < 30
		emote.scale = $ + (sin(emote.threshold*ANG1*6) >> 1)
		emote.rollangle = FixedMul(sin(emote.threshold*ANG30), ANG15)
	end
end

if not CC_NeckSkins
	rawset(_G, "CC_NeckSkins", {})
end

// Pointy Sonic
CC_NeckSkins["pointy"] = {
	skin = "pointy",
	speed = FRACUNIT/5,
	pivot = true,
	pitches = 5,
	idleangle = -ANGLE_45,
	superidleangle = 0,
	superidlepitch = -ANGLE_45,
	superpivot = false,
	superpitches = 3,
	superpitchinterval = ANG20*2,
	superstand = true,
	superfloatthreshold = 20*FRACUNIT,
	eastereggname = "\x70\048\x31\110\x74\032\x65\045\x73\111\x6e\105\x63",
	trackables = {
		{ // cash confetti when spawned via emote wheel
			condition = function(item, player)
				return item.state == S_CHRISPY_CASH
				and item.flags2 & MF2_SKULLFLY
				and item.target == player.mo
			end,
			emotesprite = SPR_EMOT,
			emoteframe = M, // $ Fang
			emotecolor = SKINCOLOR_DREAMY,
			emotesound = sfx_mario4,
			emotethink = EF.Cash,
			fangmoney = true // identifier for emote wheel
		},
		{ // rings/coins when none are possessed
			condition = function(item, player)
				return player.rings < 1 and player.bot == CC.BOT_NONE
				and (item.type == MT_RING or item.type == MT_FLINGRING
					or item.type == MT_COIN or item.type == MT_FLINGCOIN
					or item.type == MT_REDTEAMRING and player.ctfteam == 1
					or item.type == MT_BLUETEAMRING and player.ctfteam == 2)
			end,
			emotesprite = SPR_EMOT,
			emoteframe = A, // squiggle
			emotecolor = SKINCOLOR_MAGENTA,
			emotesound = sfx_emot1,
			emotethink = EF.Squiggle,
			squiggle = true // identifier for emote wheel
		},
		{ // air bubbles when underwater
			condition = function(item, player)
				return item.type == MT_EXTRALARGEBUBBLE
				and player.powers[pw_underwater] > 0 and player.powers[pw_underwater] < 20*TICRATE end,
			emotesprite = SPR_EMOT,
			emoteframe = A, // squiggle
			emotecolor = SKINCOLOR_MAGENTA,
			emotesound = sfx_emot1,
			emotethink = EF.Squiggle
		},
		{ // ACZ3 Fang KO
			condition = function(item) return item.state == S_FANG_KO and item.type == MT_FANG end,
			emotesprite = SPR_EMOT,
			emoteframe = F, // chaojoy
			emotecolor = SKINCOLOR_SKY,
			emotesound = sfx_ghosty,
			emotethink = EF.Giggle,
			ignorehealthcheck = true,
			chaojoy = true // identifier for emote wheel
		},
		{ // ACZ3 Fang
			condition = function(item) return item.type == MT_FANG and item.state ~= S_FANG_INTRO12 end,
			emoteskin = "fang",
			emotestate = S_PLAY_ICON1,
			emotesound = sfx_emot3,
			emotethink = EF.PlayerIcon,
			ignorehealthcheck = true
		},
		{ // BCZ Metal Sonic
			condition = function(item) return item.type == MT_METALSONIC_RACE or item.type == MT_METALSONIC_BATTLE end,
			emoteskin = "metalsonic",
			emotestate = S_PLAY_ICON1,
			emotesound = sfx_emot3,
			emotethink = EF.PlayerIcon
		},
		{ // FHZ Amy
			condition = function(item) return item.type == MT_ROSY end,
			emoteskin = "amy",
			emotestate = S_PLAY_ICON1,
			emotesound = sfx_emot4,
			emotethink = EF.PlayerIcon
		},
		{ // Eggman bosses
			condition = function(item)
				return item.type == MT_EGGMOBILE
				or item.type == MT_EGGMOBILE2
				or item.type == MT_EGGMOBILE3
				or item.type == MT_EGGMOBILE4
				or item.type == MT_BLACKEGGMAN
				or item.type == MT_CYBRAKDEMON
			end,
			emotesprite = SPR_EMOT,
			emoteframe = J, // eggman face
			emotesound = sfx_emot3,
			emotethink = EF.Icon,
			ignorehealthcheck = true,
			eggman = true // identifier for emote wheel
		},
		{ // bosses & enemy players
			condition = function(item, player)
				return item.flags & MF_BOSS
				or item.type == MT_FAKEMOBILE
				or item.player and not item.player.spectator
				and (item.player.ctfteam ~= player.ctfteam
					or G_RingSlingerGametype()
					and (not (gametyperules & (GTR_TAG|GTR_TEAMS)) or player.pflags & PF_TAGIT ~= item.player.pflags & PF_TAGIT))
			end,
			emotesprite = SPR_EMOT,
			emoteframe = C, // !
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotesound = sfx_emot3,
			emotethink = EF.Exclamation,
			exclamation = true // identifier for emote wheel
		},
		{ // enemies/hazards
			condition = function(item, player)
				if item.flags & (MF_ENEMY|MF_PAIN|MF_FIRE|MF_MISSILE) or item.type == MT_EGGROBO1
					local dmgtoshield = {
						[DMG_WATER] = SH_PROTECTWATER,
						[DMG_FIRE] = SH_PROTECTFIRE,
						[DMG_ELECTRIC] = SH_PROTECTELECTRIC,
						[DMG_SPIKE] = SH_PROTECTSPIKE
					}
					if item.flags & MF_SCENERY
					or item.flags & MF_MISSILE and item.target == player.mo
					or item.flags & MF_FIRE and player.powers[pw_shield] & SH_PROTECTFIRE
					or player.powers[pw_shield] & (dmgtoshield[item.info.mass & ~(8|16|32|64)] or 0)
						return false
					end
					return true
				end
			end,
			emotesprite = SPR_EMOT,
			emoteframe = C, // !
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotesound = sfx_emot3,
			emotethink = EF.Exclamation
		},
		{ // high-priority sneezables
			condition = function(item, player) return item.type == MT_SUSPICIOUSFACESTABBERSTATUE and not player.powers[pw_super] end,
			emotesprite = SPR_EMOT,
			emoteframe = B,
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotethink = EF.Sneeze,
			cusval = 1,
			sneeze = true // identifier for Fluffy Tails
		},
		{ // highscore money
			condition = function(item) return item.state == S_CHRISPY_CASH or item.state == S_CHRISPY_COIN end,
			emotesprite = SPR_EMOT,
			emoteframe = M, // $ Fang
			emotecolor = SKINCOLOR_DREAMY,
			emotesound = sfx_mario4,
			emotethink = EF.Cash
		},
		{ // dancing players
			condition = function(item) return item.state == S_CHRISPY_DANCE and item.player end,
			emotesprite = SPR_EMOT,
			emoteframe = G,
			emotethink = EF.Clap
		},
		{ // dabbing players, if you're a dabber
			condition = function(item, player)
				return item.state == S_CHRISPY_DAB
				and not player.cc_haterenabled
			end,
			emotesprite = SPR_NULL,
			emotesound = sfx_emot6,
			emotethink = EF.DabParticles
		},
		{ // hating players, if you're a hater
			condition = function(item, player)
				return item.state == S_CHRISPY_HATER
				and player.cc_haterenabled
			end,
			emotesprite = SPR_EMOT,
			emoteframe = E, // ok hand
			emotesound = sfx_emot0,
			emotethink = EF.OkHand,
			okhand = true // identifier for emote wheel
		},
		{ // dabbing players, if you're a hater, or hating players, if you're a dabber
			condition = function(item, player)
				return item.state == S_CHRISPY_DAB
				and player.cc_haterenabled
				or item.state == S_CHRISPY_HATER
				and not player.cc_haterenabled
			end,
			emotesprite = SPR_EMOT,
			emoteframe = I, // shadow
			emotecolor = SKINCOLOR_RED,
			emotesound = sfx_emot1,
			emotethink = EF.Hater,
			hater = true // identifier for hater feature/emote wheel
		},
		{ // speedy players
			condition = function(item, player)
				return item.player and item.player.speed > 48*player.mo.scale
			end,
			emotesprite = SPR_EMOT,
			emoteframe = K, // surprised pikachu
			emotecolor = SKINCOLOR_SAPPHIRE,
			emotesound = sfx_emot3,
			emotethink = EF.Surprised,
			surprised = true // identifier for emote wheel
		},
		{ // t-posing players
			condition = function(item, player)
				return item.player and item.sprite2 == SPR2_TPOS and item.sprite == SPR_PLAY
			end,
			emotesprite = SPR_EMOT,
			emoteframe = O,
			emotecolor = SKINCOLOR_SAPPHIRE,
			emotesound = sfx_emot0,
			emotethink = function(emote, item, mo)
				if item.skin == "pointy"
					emote.color = item.player.skincolor
				else
					emote.color = skins["pointy"].prefcolor
				end
			end,
			tpose = true // identifier for emote wheel
		},
		{ // players
			condition = function(item, player)
				return item.player
				and (item.player.bot == CC.BOT_2PAI) == (player.bot == CC.BOT_2PAI)
				and not item.player.spectator
			end,
			emotestate = S_PLAY_ICON1,
			emotesound = sfx_emot4,
			emotethink = EF.PlayerIcon
		},
		{ // starposts / goalposts
			condition = function(item, player)
				return (item.type == MT_STARPOST
				and item.spawnpoint and item.spawnpoint.angle/360 > player.starpostnum - 1
				or item.type == MT_SIGN
				and not player.exiting)
				and player.bot == CC.BOT_NONE
			end,
			emotesprite = SPR_EMOT,
			emoteframe = C, // !
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotesound = sfx_emot0,
			emotethink = EF.Question
		},
		{ // sneezeables
			condition = function(item, player)
				return (item.flags & MF_ENEMY or item.player and item.player.ctfteam ~= player.ctfteam) and not player.powers[pw_super]
			end,
			emotesprite = SPR_EMOT,
			emoteframe = B,
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotethink = EF.Sneeze,
			cusval = 1,
			ignoresightcheck = true,
			sneeze = true // identifier for Fluffy Tails
		},
		{ // monitors
			condition = function(item) return item.flags & MF_MONITOR end,
			emotesprite = SPR_EMOT,
			emoteframe = B, // ?
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotesound = sfx_emot2,
			emotethink = EF.Question,
			cusval = 1,
			question = true // identifier for emote wheel
		},
		{ // emeralds/tokens/emblems/flags
			condition = function(item)
				return item.type >= MT_TOKEN
				and item.type <= MT_FLINGEMERALD
			end,
			emotesprite = SPR_EMOT,
			emoteframe = B, // ?
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotesound = sfx_emot2,
			emotethink = EF.Question,
			cusval = 1
		},
		{ // Eggman statues
			condition = function(item) return item.type == MT_EGGSTATUE or item.type == MT_EGGSTATUE2 end,
			emotesprite = SPR_EMOT,
			emoteframe = J, // eggman face
			emotesound = sfx_emot0,
			emotethink = EF.Icon
		},
		{ // pushables/misc
			condition = function(item, player)
				return item.flags & MF_PUSHABLE and not player.powers[pw_carry]
				or item.type == MT_STEAM
			end,
			emotesprite = SPR_EMOT,
			emoteframe = C, // !
			emotecolor = SKINCOLOR_SUPERGOLD5,
			emotesound = sfx_emot0,
			emotethink = EF.Question
		},
		{ // flickies
			condition = function(item) return item.type >= MT_FLICKY_01 and item.type <= MT_SECRETFLICKY_02 end,
			emotesprite = SPR_EMOT,
			emoteframe = D, // <3
			emotecolor = SKINCOLOR_ROSY,
			emotesound = sfx_emot4,
			emotethink = function(emote)
				EF.Bob(emote)
				if leveltime/3 % 7 == 0
					emote.scale = 4*$/3
					emote.z = $ - 8*P_MobjFlip(emote)*emote.scale/3
				end
			end,
			heart = true // identifier for emote wheel
		},
		{ // Mario mode coins
			condition = function(item) return item.type == MT_COIN or item.type == MT_FLINGCOIN end,
			emotesprite = SPR_EMOT,
			emoteframe = M, // $ Fang
			emotecolor = SKINCOLOR_DREAMY,
			emotesound = sfx_mario4,
			emotethink = EF.Cash
		},
		{ // bots
			condition = function(item, player)
				if item.player
				and (item.player.bot == CC.BOT_2PAI) ~= (player.bot == CC.BOT_2PAI)
				and not item.player.spectator
					local neck = item.neck
					if neck
						if neck.target == player.mo
							player.mo.neck.cc_botskip = true
						elseif player.mo.neck.cc_botskip
						and neck.cc_botskip
							return false
						end
					end
					return true
				end
			end,
			emotestate = S_PLAY_ICON1,
			emotesound = sfx_emot4,
			emotethink = EF.PlayerIcon
		},
		// These only exist for the sake of emote wheel, hence condition always returning false
		{ // clap
			condition = function() return false end,
			emotesprite = SPR_EMOT,
			emoteframe = G,
			emotethink = function(emote)
				if emote.movedir ~= emote.lastlook
					emote.threshold = 2*TICRATE/3
				end
				
				if emote.threshold
					emote.threshold = $ - 1
					if emote.threshold < EF.CLAPTIME
						if emote.threshold == EF.CLAPTIME - 1
							S_StartSound(mo, sfx_emot5)
						end
						emote.frame = $ + 1
					end
				end
			end,
			clap = true
		},
		{ // tailsthink
			condition = function() return false end,
			emotesprite = SPR_EMOT,
			emoteframe = L,
			emotecolor = SKINCOLOR_COPPER,
			emotesound = sfx_emot0,
			emotethink = function(emote, item, mo)
				EF.Bob(emote)
				if mo.skin == "fluffy"
					emote.color = mo.player.skincolor
				else
					emote.color = skins["fluffy"].prefcolor
				end
			end,
			thinking = true
		},
		{ // high-five
			condition = function() return false end,
			emotesprite = SPR_EMOT,
			emoteframe = N,
			emotesound = sfx_emot4,
			emotethink = function(emote)
				emote.threshold = ($ + 1) % 40
				if emote.threshold < 20
					local n = emote.threshold % 10
					emote.scale = $ + (sin(n*ANG2*9) >> 1)
				end
			end,
			highfive = true
		}
	}
}

// Fluffy Tails
CC_NeckSkins["fluffy"] = {
	skin = "fluffy",
	speed = FRACUNIT/5,
	pivot = true,
	pitches = 5,
	idleangle = -ANGLE_45,
	idlepitch = ANG30,
	emoteoffset = 6*FRACUNIT,
	eastereggname = "\102\x6c\117\x66\102\x20\101\x2d\116\x34\049\x6c\053",
	trackables = {},
}
for _, item in ipairs(CC_NeckSkins["pointy"].trackables) // Use all of Pointy's trackables except for sneezes
	if not item.sneeze
		table.insert(CC_NeckSkins["fluffy"].trackables, item)
	end
end