/*
Peelout Ghosts
	by Lach

v1.2
*/

// why do I have a separate script for this?
// this was supposed to go in POINTY-SONIC.lua, but I needed to use a PostThinkFrame that runs after Fluffy Tails' script, and it doesn't belong in there

local SKIN = "pointy"
local CC = ChrispyChars

CC.SKINCOLOR_GHOST = SKINCOLOR_ICY // color to colorize the peelout ghost objects when player is their prefcolor
CC.GHOST_INTERPMODE = 1 // interpolation mode for ghosts

CC.ghostQueue = {}

CC.SpawnGhosts = function(mo)
	local rets = {}
	local ghost = P_SpawnGhostMobj(mo)
	
	// insert base ghost
	ghost.interpmode = CC.GHOST_INTERPMODE
	table.insert(rets, ghost)
	
	// insert followmobj ghost
	if ghost.tracer
		ghost.tracer.interpmode = CC.GHOST_INTERPMODE
		table.insert(rets, ghost.tracer)
	end
	
	// insert tails ghosts
	if mo.fluffytails
		for _, tail in ipairs(mo.fluffytails.tails)
			ghost = P_SpawnGhostMobj(tail)
			ghost.interpmode = CC.GHOST_INTERPMODE
			table.insert(rets, ghost)
		end
	end
	return rets
end

local function DoPeeloutGhost(player, refobj, prevpos, ghosts)
	local ghost = ghosts[1]
	local mo = player.mo
	
	ghost.tics = 2
	ghost.colorized = true
	if mo == refobj and mo.color == player.skincolor and player.skincolor == skins[SKIN].prefcolor
		ghost.color = CC.SKINCOLOR_GHOST
	end
	P_TeleportMove(ghost,
		ghost.x + prevpos[1] - refobj.x,
		ghost.y + prevpos[2] - refobj.y,
		ghost.z + prevpos[3] - refobj.z)
	
	for i = 2, #ghosts
		local tracer = ghosts[i]
		tracer.fuse = ghost.fuse
		tracer.tics = ghost.tics
		tracer.color = ghost.color
		tracer.colorized = ghost.colorized
		P_TeleportMove(tracer,
			tracer.x + prevpos[1] - refobj.x,
			tracer.y + prevpos[2] - refobj.y,
			tracer.z + prevpos[3] - refobj.z)
	end
end

CC.QueueGhost = function(player, prevpos, refobj)
	table.insert(CC.ghostQueue, {
		player = player,
		prevpos = prevpos,
		refobj = refobj
	})
end

ChrispyChars.AddHook("PostThinkFrame", do
	if #CC.ghostQueue
		for _, item in ipairs(CC.ghostQueue)
			DoPeeloutGhost(item.player, item.refobj, item.prevpos, CC.SpawnGhosts(item.player.mo))
		end
		CC.ghostQueue = {}
	end
end)