/*
Update notices on the title screen
	by Lach

v1
*/

if TitleUpdateNotices // already loaded
	return
end

rawset(_G, "TitleUpdateNotices", {})

local ERRSTRING = "%s\128 requires SRB2 v2.2.%d or newer."
local UPDATESTRING = "\128Please update your game.\n\132https://www.srb2.org/download/\128"

local referencePatch
local lineHeight = 0

hud.add(function(v)
	local numNotices = #TitleUpdateNotices
	
	if numNotices == 0
		return
	end
	
	local y = 8
	local flags = V_SNAPTOLEFT|V_SNAPTOTOP|V_ALLOWLOWERCASE
	
	if not (referencePatch and referencePatch.valid)
		referencePatch = v.cachePatch("TNYFN065") // A
		lineHeight = referencePatch.height + 1
	end
	
	for i = 1, numNotices
		local addon = TitleUpdateNotices[i]
		local notice = string.format(ERRSTRING, addon[1], addon[2])
		v.drawString(16, y, notice, flags, "thin")
		y = $ + lineHeight
	end
	v.drawString(16, y, UPDATESTRING, flags, "thin")
end, "title")